/* 
Intic Lock widget (1.3) for Mac OS X 10.4.3
Patrick Heck (heckp@gmx.de), 30/01/09

Copyright (C) 2009 Patrick Heck

This file is part of Intic Lock.

Deep Sleep is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Deep Sleep is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Intic Lock. If not, see <http://www.gnu.org/licenses/>.
*/

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
	loadpreferences();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    widget.setPreferenceForKey(null, createInstancePreferenceKey("action"));
    widget.setPreferenceForKey(null, createInstancePreferenceKey("color"));
}


//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    loadpreferences();
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}





function gotoHomepage(event)
{
	if ( window.widget ) {
	widget.openURL( "http://www.intic.de" );
	return false;
	}
}




function changelockcolor(event)
{
	if ( window.widget ) {
    document.getElementById("padlock").src = "padlock_" + document.getElementById("popup").value +".png";
	}
}


function lockScreen(event)
{
    if (window.widget)
	{
		// Values you provide
        /*var itemToMove = document.getElementById("lock");	// replace with ID of element to move
        var moveToTopPosition = 10;							// new top CSS value

        // Moving code
        var originalTop = parseInt(document.defaultView.getComputedStyle(itemToMove, null).getPropertyValue("top"));
        var moveHandler = function(a, c, s, f){ itemToMove.style.top = c + "px"; };
        currentAnimator = new AppleAnimator(200, 13);
        firstAnimation = new AppleAnimation(originalTop, moveToTopPosition, moveHandler);
        secondAnimation = new AppleAnimation(moveToTopPosition, originalTop, moveHandler);
        currentAnimator.addAnimation(firstAnimation);
        currentAnimator.addAnimation(secondAnimation);
        currentAnimator.start();
        */ // new AppleAnimator(200, 13, originalTop, moveToTopPosition, moveHandler ).start();

        widget.system('"/System/Library/CoreServices/Menu\ Extras/User.menu/Contents/Resources/CGSession" -suspend ', null);
		var action = document.getElementById("actionpopup").value;
		if (action == "sleeplock") {
			// goto sleep
			widget.system ("/usr/bin/osascript -e 'tell application \"Finder\" to sleep'", null);
		}
	}
}




function mouseoverLock(event)
{
    // Values you provide
var itemToFadeIn = document.getElementById("shine");

// Fading code
var fadeHandler = function(a, c, s, f){ itemToFadeIn.style.opacity = c; };
new AppleAnimator(200, 13, 0.0, 1.0, fadeHandler).start();

}


function mouseoutLock(event)
{
    // Values you provide
var itemToFadeOut = document.getElementById("shine");

// Fading code
var fadeHandler = function(a, c, s, f){ itemToFadeOut.style.opacity = c; };
new AppleAnimator(200, 13, 1.0, 0.0, fadeHandler).start();

}


function savepreferences(event)
{
	var newaction = document.getElementById("actionpopup").value;
	var newcolor = document.getElementById("popup").value;
    widget.setPreferenceForKey( newaction , "action");
	widget.setPreferenceForKey( newcolor , "color");
	changelockcolor();
}

function loadpreferences()
{
	if (!(widget.preferenceForKey("action") === undefined)) {
		var thisaction = widget.preferenceForKey("action");
	}
	if (!(widget.preferenceForKey("color") === undefined)) {
		var thiscolor = widget.preferenceForKey("color");
	}
	
	if (thisaction && thisaction.length > 0) {
		document.getElementById("actionpopup").value = thisaction;
	}
	if (thiscolor && thiscolor.length > 0) {
		document.getElementById("popup").value = thiscolor;
	}
	changelockcolor();
}